#	CERG
#	Bilal Habib
#	Dec 28, 2015
#	Configuration file used for storing the Parameters. These paremeters are then passed to PUF schemes.

##################################################################################
import math                                                                      #
import itertools                                                                 #
from itertools import combinations                                               #
                                                                                 #
def bits_per_set_BLG(S):                                                         #
	bits_per_set =0                                                              #
	for i in range (2,S+1):                                                      #
		bits_per_set += math.ceil(math.log(i,2))                                 #
	return bits_per_set                                                          #
	                                                                             #
def components_S_ArbRO(K,L):                                                     #
	temp = 0                                                                     #
	for i in range(K,L):                                                         #
		temp =  len(list(itertools.combinations(range(i),K))) * pow(2,(K-1))     #
		if(temp>L):                                                              #
			return i*2	# 2 components per Element.                              #
                                                                                 #
def components_Id_map(t,L):                                                      #
	temp = 0                                                                     #
	for i in range(t+1,L):                                                       #
		temp = len(list(itertools.combinations(range(i),t)))                     #
		if(temp>L):                                                              #
			return i                                                             #
		                                                                         #
################    DONOT WRITE ABOVE THIS LINE     ##############################

#Input file containing the Raw data
inputfile = 'VT_Enrolment_data.csv'					

#Number of Devices	
num_devices = 193

#Number of PUF response bits to generate
Response_bit_length = 128

#Directory Name of field input data required for Reliability
field_directory = 'VT_field'
#File Name in the Field Directory at nominal conditions required for Reliability
field_nominal = '1.2V_25C.csv'

field_nominal_file = field_directory+ '/' + field_nominal

#Minimum Number of Components required for Pairwise Comparison (PC scheme)
Num_components_PC = Response_bit_length * 2

#Minimum Number of Components required for Comparing the Neighboring Components (CNC scheme)
Num_components_CNC = Response_bit_length + 1

####################################### Binary Lehmer Gray Scheme ################ 
#Set size for Binary Lehmer Gray (BLG scheme)
set_size = 8							

#Minimum Number of Components required for Binary Lehmer Gray scheme.
Num_components_BLG =  math.ceil (Response_bit_length/bits_per_set_BLG(set_size)) * set_size
####################################### S-ArbRO-2 Scheme ######################### 	
#Parameter K, for S-ArbRO-2
S_ArbRO_K = 2	

#Minimum Number of Components required for S-ArbRO-2 scheme
Num_components_S_ArbRO = components_S_ArbRO(S_ArbRO_K,Response_bit_length) 
####################################### ID Mapping Scheme ######################## 
#Input file for Id-Mapping, nominal
Id_Map_input_file = field_directory+ '/' + field_nominal


#Input file for Id-Mapping, field
#Id_Map_field_file = field_directory + '/' + '1.32V_25C.csv'

#Parameter q for Identity Mapping
Id_Map_q = 30	 

#Id-Mapping , Row number to select a particular device
row = 2

#Parameter e for Identity Mapping
Id_Map_e = 0.5	

#Parameter t for Identity Mapping
Id_Map_t = 2	

#Minimum Number of components required for Identity Mapping
Num_components_Id_Map = components_Id_map(Id_Map_t, Response_bit_length)
################################################################################## 